<?php // $Id: mambo.inc.php,v 1.6 2006/07/06 15:21:15 moosh Exp $
if ( count( get_included_files() ) == 1 ) die( '---' );
/**
 * CLAROLINE
 *
 * @version 1.8 $Revision: 1.6 $
 *
 * @copyright (c) 2001-2006 Universite catholique de Louvain (UCL)
 *
 * @license http://www.gnu.org/copyleft/gpl.html (GPL) GENERAL PUBLIC LICENSE
 *
 * @package CLAUTH
 *
 * @author Claro Team <cvs@claroline.net>
 */

$authSourceName = 'mambo';
$authSourceType = 'DB';

// Define the Auth driver options

$extAuthOptionList = array(

    // PUT HERE THE CORRECT DSN FOR YOUR DB SYSTEM
    'dsn'         => 'mysql://root:@localhost/mambo',

    'table'       => 'mos_users', // warning ! table prefix can change from one system to another
    'usernamecol' => 'username',
    'passwordcol' => 'password',
    'db_fields'   => array('name', 'email', 'usertype'),
    'cryptType'   => 'md5'
);


// Link additionnal external authentication attributes to the Claroline
// user attribute.
//
// array KEYS   are the Claroline attributes and
// array VALUES are the authentication external attributes.

$extAuthAttribNameList = array (
    'lastname'     => 'name',
    'email'        => 'email'
);

// Array setting optionnal preliminary treatment to the data retrieved from the
// exernal authentication source. Array KEYS are the concernend claroline
// user table fields, and Array VALUES are either the name of a function which
// makes the treatment or simply a default value to insert
// Note. Treatments doesn't necessary previously require data from the external
// authentication system. They're able to be trigged from NULL value ...

$extAuthAttribTreatmentList = array ();

// PROCESS AUTHENTICATION

return require dirname(__FILE__).'/../extAuthProcess.inc.php';

?>